﻿using System.Collections.Generic;
using System.Linq;
using System.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Data;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.ServiceModel.DomainServices.Client;
using Telerik.Windows.Controls.DomainServices;
using SilverlightApplication1.Web.Services;
using System.Threading;
using System;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		RadObservableCollection<string> distinctValues = new RadObservableCollection<string>();

		public MainPage()
		{
			InitializeComponent();
		}
		
		private void OnRadGridViewDistinctValuesLoading(object sender, GridViewDistinctValuesLoadingEventArgs e)
		{
			this.distinctValues.Clear();
			e.ItemsSource = this.distinctValues;

			this.distinctValuesDataSource.QueryParameters[0].Value = e.Column.GetDataMemberName();
			this.distinctValuesDataSource.Load();
		}

		private void OnDistinctValuesDataSourceLoadingData(object sender, LoadingDataEventArgs e)
		{
			e.LoadBehavior = LoadBehavior.RefreshCurrent;
		}

		private void OnDistinctValuesDataSourceLoadedData(object sender, Telerik.Windows.Controls.DomainServices.LoadedDataEventArgs e)
		{
			this.distinctValues.AddRange(e.Entities.Cast<DistinctValue>().Select(dv => dv.Value));
		}

		DateTime startTime;
		private void OnCustomersDataSourceLoadingData(object sender, LoadingDataEventArgs e)
		{
			startTime = DateTime.Now;
			var query = e.Query.Query.ToString().Replace("SilverlightApplication1.Web.Models.Customer[]", "Customers");
			this.debugTextBox.Text += string.Format("{0}: Sending query to server: {1}\r\n"
				, this.startTime.ToString("hh:mm:ss.fff")
				, query);
		}

		private void OnCustomersDataSourceLoadedData(object sender, LoadedDataEventArgs e)
		{
			if (e.HasError)
			{
				e.MarkErrorAsHandled();
				this.debugTextBox.Text += string.Format("{0}: Server returned the following error: {1}\r\n"
					, DateTime.Now.ToString("hh:mm:ss.fff")
					, e.Error);
			}
			else
			{
				var elapsedTime = DateTime.Now - this.startTime;
				this.debugTextBox.Text += string.Format("{0}: Server returned {1} entities {2} ms\r\n"
					, DateTime.Now.ToString("hh:mm:ss.fff")
					, e.Entities.Count()
					, elapsedTime.Milliseconds);
			}
		}

		private void OnDebugTextBoxTextChanged(object sender, TextChangedEventArgs e)
		{
			this.debugScrollViewer.ScrollToVerticalOffset(this.debugScrollViewer.ExtentHeight);
		}
	}
}
